function [T,X,Y,Z]=tricube(n)

nX=2*n+1;
nY=round(2*n*sqrt(3));
if ~mod(nY,2)
  nY=nY+1;
end

lx=linspace(-1,1,nX);
%lx(end)=[];
dx=lx(2)-lx(1);
ly=linspace(-1,1,nY);
dy=ly(2)-ly(1);

[x,y]=meshgrid(lx,ly);

X=x;
Y=y;

X(:,end)=[];
Y(:,end)=[];
X(end,:)=[];
Y(end,:)=[];

x=[reshape(x,[1 numel(x)]) reshape(X+dx*0.5,[1 numel(X)])];% linspace(-1+dx*0.5,1-dx*0.5,nX-1) linspace(-1+dx*0.5,1-dx*0.5,nX-1)];
y=[reshape(y,[1 numel(y)]) reshape(Y+dy*0.5,[1 numel(Y)])];% ones(1,nX-1) -ones(1,nX-1)];

f=find(abs(y)==1);
x(f)=[];
y(f)=[];

x=[x ly                  ly];
y=[y ones(1,length(ly)) -ones(1,length(ly))];
z=ones(1,length(x));

T=delaunay(x,y);

N=size(x,2);

P=[ [x;y;z] [z;x;y] [y;z;x] [y;x;-z] [-z;y;x] [x;-z;y] ];

X=P(1,:);
Y=P(2,:);
Z=P(3,:);

T=[T;T+1*N;T+2*N;T+3*N;T+4*N;T+5*N];

xtrisave('cube',T,[X;Y;Z]);

