function [T,X,Y,Z]=tricylinder(n)

nX=round(2*pi*n);
if ~mod(nX,2)
  nX=nX+1;
end

nY=round(2*n*sqrt(3));
if ~mod(nY,2)
  nY=nY+1;
end

lx=linspace(-pi,pi,nX);
dx=lx(2)-lx(1);
ly=linspace(-1,1,nY);
dy=ly(2)-ly(1);

[x,y]=meshgrid(lx,ly);

X=x;
Y=y;

X(:,end)=[];
Y(:,end)=[];
X(end,:)=[];
Y(end,:)=[];

x=[reshape(x,[1 numel(x)]) reshape(X+dx*0.5,[1 numel(X)]) linspace(-pi+dx*0.5,pi-dx*0.5,nX-1) linspace(-pi+dx*0.5,pi-dx*0.5,nX-1)];
y=[reshape(y,[1 numel(y)]) reshape(Y+dy*0.5,[1 numel(Y)]) ones(1,nX-1) -ones(1,nX-1)];

T1=delaunay(x,y);

X1=[cos(x);sin(x);y];
sX1=size(X1,2);

fp=find(x==+pi);
fm=find(x==-pi);

for c1=1:length(fp)
  T1(find(T1==fp(c1)))=fm(c1);
end

%clf reset
%subplot(3,1,1)
%trimesh(T1,x,y)
%axis equal

%subplot(3,1,2)

f=find(1==y);
an=x(f);
cx=cos(an);
cy=sin(an);

%plot(cx,cy,'+')
%axis equal
%hold on

r=sqrt(x.*x+y.*y);
f=find(r<1);
X2=[x(f) cx;y(f) cy];
%plot(X2(1,:),X2(2,:),'or')

sX2=size(X2,2);

T2=delaunay(X2(1,:),X2(2,:));

X2=[X2                  X2                 ;
    ones(1,size(X2,2)) -ones(1,size(X2,2))  ];
    
%trimesh(T2,X2(1,:),X2(2,:))
%subplot(3,1,3)


X=[X2 X1];

T=[T2;T2(:,[1 3 2])+sX2;T1+2*sX2];

P=X;

X=P(1,:);
Y=P(2,:);
Z=P(3,:);

xtrisave('cylinder',T,[X;Y;Z]);
