function [T,X,Y,Z]=tritorus(rt,n)

if rt<=1
  error('ratio of radii for torus must be greater than 1')
end

R=1;
r=R/rt;

N=round(n*r);
N=N+~mod(N,2);

p1=[];
p2=[];

for x2=linspace(0,2*pi,N)
  x1=linspace(0,2*pi,round(n*(R+r*cos(x2))));
  p1=[p1 x1];
  p2=[p2 repmat(x2,[1 length(x1)])];
end

T=delaunay(p1,p2);

for c1=[find(p1==0)
        find(p1==2*pi)]
  T(find(T==c1(2)))=c1(1);
end

for c1=[find(p2==0)
        find(p2==2*pi)]
  T(find(T==c1(2)))=c1(1);
end

X=(R+r*cos(p2)).*cos(p1);
Y=(R+r*cos(p2)).*sin(p1);
Z=r*sin(p2);

xtrisave(['torus_' num2str(rt)],T,[X;Y;Z]);
